<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-row dense>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="companyName"
              v-model="obj.companyName"
              dense
              :readonly="formState.readOnly"
              :label="$sock.t('TrialLicenseRequestCompanyName')"
              :rules="[form().required(this, 'companyName')]"
              :error-messages="form().serverErrors(this, 'companyName')"
              data-cy="companyName"
              @input="fieldValueChanged('companyName')"
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="contactName"
              v-model="obj.contactName"
              dense
              :readonly="formState.readOnly"
              :label="$sock.t('TrialLicenseRequestContactName')"
              :rules="[form().required(this, 'contactName')]"
              :error-messages="form().serverErrors(this, 'contactName')"
              data-cy="contactName"
              @input="fieldValueChanged('contactName')"
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="dbId"
              v-model="obj.dbId"
              dense
              :readonly="formState.readOnly"
              :label="$sock.t('DatabaseID')"
              :rules="[form().required(this, 'dbId')]"
              :error-messages="form().serverErrors(this, 'dbId')"
              data-cy="dbId"
              @input="fieldValueChanged('dbId')"
            ></v-text-field>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-email
              ref="email"
              v-model="obj.email"
              :readonly="formState.readOnly"
              :label="$sock.t('TrialLicenseRequestEmail')"
              data-cy="email"
              :error-messages="form().serverErrors(this, 'email')"
              @input="fieldValueChanged('email')"
            ></gz-email>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-checkbox
              ref="emailValidated"
              v-model="obj.emailValidated"
              dense
              readonly
              :label="$sock.t('TrialLicenseRequestEmailValidated')"
              data-cy="emailValidated"
              :error-messages="form().serverErrors(this, 'emailValidated')"
              @change="fieldValueChanged('emailValidated')"
            ></v-checkbox>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-date-time-picker
              ref="requested"
              v-model="obj.requested"
              :label="$sock.t('TrialLicenseRequestRequested')"
              readonly
            ></gz-date-time-picker>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-date-time-picker
              ref="processed"
              v-model="obj.processed"
              :label="$sock.t('TrialLicenseRequestProcessed')"
              readonly
            ></gz-date-time-picker>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <gz-date-time-picker
              ref="fetchedOn"
              v-model="obj.fetchedOn"
              :label="$sock.t('TrialLicenseRequestFetchedOn')"
              :readonly="formState.readOnly"
              :error-messages="form().serverErrors(this, 'fetchedOn')"
              data-cy="fetchedOn"
              @input="fieldValueChanged('fetchedOn')"
            ></gz-date-time-picker>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-select
              ref="status"
              v-model="obj.status"
              dense
              :items="selectLists.trialRequestStatus"
              item-text="name"
              item-value="id"
              :readonly="formState.readOnly"
              :label="$sock.t('TrialLicenseRequestStatus')"
              :rules="[form().integerValid(this, 'status')]"
              :error-messages="form().serverErrors(this, 'status')"
              data-cy="status"
              @input="fieldValueChanged('status')"
            ></v-select>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-checkbox
              ref="perpetual"
              v-model="obj.perpetual"
              dense
              readonly
              :label="$sock.t('TrialLicenseRequestPerpetual')"
            ></v-checkbox>
          </v-col>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="rejectReason"
              v-model="obj.rejectReason"
              dense
              :readonly="formState.readOnly"
              :label="$sock.t('TrialLicenseRequestRejectReason')"
              :error-messages="form().serverErrors(this, 'rejectReason')"
              data-cy="rejectReason"
              @input="fieldValueChanged('rejectReason')"
            ></v-text-field>
          </v-col>
          <v-col cols="12">
            <v-textarea
              ref="key"
              v-model="obj.key"
              dense
              readonly
              :label="$sock.t('LicenseKey')"
              auto-grow
            ></v-textarea>
          </v-col>

          <!-- --------------------------------- -->

          <v-col v-if="form().showMe(this, 'Tags')" cols="12">
            <gz-tag-picker
              ref="tags"
              v-model="obj.tags"
              :readonly="formState.readOnly"
              data-cy="tags"
              :error-messages="form().serverErrors(this, 'tags')"
              @input="fieldValueChanged('tags')"
            ></gz-tag-picker>
          </v-col>
        </v-row>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "trial-license-request-edit";
const API_BASE_URL = "trial-license-request/";
const FORM_CUSTOM_TEMPLATE_KEY = "TrialLicenseRequest";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      obj: {
        id: 0,
        concurrency: 0,
        dbId: null,
        companyName: null,
        contactName: null,
        email: null,
        emailConfirmCode: null,
        emailValidated: false,
        requested: null,
        processed: null,
        status: 0,
        rejectReason: null,
        key: null,
        fetchedOn: null,
        perpetual: true,
        tags: []
      },
      selectLists: {
        trialRequestStatus: []
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      sockType: window.$gz.type.TrialLicenseRequest
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }

        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }

        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(
        window.$gz.type.TrialLicenseRequest
      );
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      //---------------------------------
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          this.obj.name = `${this.obj.name} - ${window.$gz.translation.get(
            "Copy"
          )}`;
          setDirty = true;
        }
      }
      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });
      //----------------------------
      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    sockTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "trial-request-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });

        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;

          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    duplicate() {
      this.$router.push({
        name: "trial-request-edit",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;

      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.TrialLicenseRequest,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;

      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$sockiHandHoldingWater",
    title: "TrialLicenseRequest",
    formData: {
      sockType: window.$gz.type.TrialLicenseRequest,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName: vm.obj.name
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$sockiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$sockiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$sockiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  menuOptions.menuItems.push({ divider: true, inset: false });

  // menuOptions.menuItems.push({
  //   title: "OpenTerminal",
  //   icon: "$sockiTerminal",
  //   key: FORM_KEY + ":terminal",
  //   vm: vm
  // });

  //   menuOptions.menuItems.push({
  //     title: "QuoteList",
  //     icon: "$sockiPencilAlt",
  //     key: FORM_KEY + ":QuoteList",
  //     vm: vm
  //   });

  //   menuOptions.menuItems.push({
  //     title: "PMList",
  //     icon: "$sockiBusinessTime",
  //     key: FORM_KEY + ":PMList",
  //     vm: vm
  //   });

  menuOptions.menuItems.push({ divider: true, inset: false });
  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
  await populateSelectionLists(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "TrialLicenseRequest",
    "DatabaseID",
    "TrialLicenseRequestCompanyName",
    "TrialLicenseRequestContactName",
    "TrialLicenseRequestEmail",
    "TrialLicenseRequestEmailValidated",
    "TrialLicenseRequestRequested",
    "TrialLicenseRequestProcessed",
    "TrialLicenseRequestStatus",
    "TrialLicenseRequestRejectReason",
    "TrialLicenseRequestFetchedOn",
    "TrialLicenseRequestPerpetual",
    "LicenseKey"
  ]);
}
//////////////////////
//
//
async function populateSelectionLists(vm) {
  //ensure the pick lists required are pre-fetched
  await window.$gz.enums.fetchEnumList("trialrequeststatus");
  vm.selectLists.trialRequestStatus = window.$gz.enums.getSelectionList(
    "trialrequeststatus"
  );
}
/*
"CREATE TABLE atriallicenserequest (id BIGINT GENERATED ALWAYS AS IDENTITY PRIMARY KEY, dbid TEXT NOT NULL, companyname TEXT NOT NULL, "
                                     + "contactname TEXT NOT NULL, email TEXT NOT NULL, emailconfirmcode TEXT NOT NULL, emailvalidated BOOL DEFAULT false, "
                                     + "requested TIMESTAMPTZ NOT NULL, processed TIMESTAMPTZ, status INTEGER NOT NULL DEFAULT 0, rejectreason TEXT, key TEXT, "
                                     + "fetchedon TIMESTAMPTZ, perpetual BOOL DEFAULT false NOT NULL, tags VARCHAR(255) ARRAY )"

      [Required]
        public string DbId { get; set; }
        [Required]
        public string CompanyName { get; set; }
        [Required]
        public string ContactName { get; set; }
        [Required]
        public string Email { get; set; }
        [Required]
        public string EmailConfirmCode { get; set; }
        public bool EmailValidated { get; set; } = false;
        public DateTime Requested { get; set; }
        public DateTime? Processed { get; set; }
        public TrialRequestStatus Status { get; set; } = TrialRequestStatus.New;
        public string RejectReason { get; set; }
        public string Key { get; set; }
        public DateTime? FetchedOn { get; set; }
        public bool Perpetual { get; set; } = false;        
        public List<string> Tags { get; set; }

    await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequest', 'Trial license request' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestList', 'Trial license requests' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestCompanyName', 'Company' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestContactName', 'Contact' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestEmail', 'Email address' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestEmailValidated', 'Email validated' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestRequested', 'Requested' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestProcessed', 'Processed' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestStatus', 'Status' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestRejectReason', 'Reject reason' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestFetchedOn', 'Fetched' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialLicenseRequestPerpetual', 'Perpetual' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialRequestStatusNew', 'New' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialRequestStatusApproved', 'Approved' FROM atranslation t  where t.baselanguage = 'en'");
                await ExecQueryAsync("INSERT INTO atranslationitem(translationid,key,display) SELECT t.id, 'TrialRequestStatusRejected', 'Rejected' FROM atranslation t  where t.baselanguage = 'en'");

{
  "id": 0,
  "concurrency": 0,
  "dbId": "string",
  "companyName": "string",
  "contactName": "string",
  "email": "string",
  "emailConfirmCode": "string",
  "emailValidated": true,
  "requested": "2023-01-03T23:54:50.451Z",
  "processed": "2023-01-03T23:54:50.451Z",
  "status": 0,
  "rejectReason": "string",
  "key": "string",
  "fetchedOn": "2023-01-03T23:54:50.451Z",
  "perpetual": true,
  "tags": [
    "string"
  ]
}
 */
</script>
